/*!
 gameTemplaCredits.js
 * author: Brent M. Dingle
 * last modified: 2015
 *
 * Example of a credits class and related for use with theGame singleton
 * Also uses menuButton class defined in gameTemplaMenu.js
 *
 * This can be done many different and better ways than this
 * Here we have assumed a lot of knowledge about other things
 * as well as the existence of various global items
 */

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// 'class' insetView											insetView
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
function insetView()
{
    // public member variables
	this.boxColor          = "rgb(175, 175, 175)";
	this.boxShadowColor    = "rgb(50, 50, 50)";
	this.x                 = 20;
	this.y                 = 120;
	this.width             = 230;
	this.height            = 40;
	this.text              = [ "Button Text", "Extra Text", ];
	this.textColor         = "rgb(0, 256, 256)";
    this.textTitleColor    = "rgb(0, 230, 250)";
    
    this.textStartY = 15;
};

// ----------------------------------------------------------------------------
// insetView 'class' method: coordsAreInside
// ----------------------------------------------------------------------------
insetView.prototype.coordsAreInside = function(mouseX, mouseY)
{
    if (   ((mouseX > this.x) && (mouseX < (this.x + this.width))) 
		&& ((mouseY > this.y) && (mouseY < (this.y + this.height))) )
		return true;
	else
		return false;	
};

// ----------------------------------------------------------------------------
// insetView class method: drawInsetView
// ----------------------------------------------------------------------------
insetView.prototype.drawInsetView = function(context)
{
    context.fillStyle = this.boxColor;
    context.fillRect(this.x-2, this.y-2, this.width, this.height);
    context.fillStyle = this.boxShadowColor;
    context.fillRect(this.x, this.y, this.width, this.height);
    context.fillStyle = this.textColor;
    
    // Print text array, each entry is assume one line and fits
    var i = 0;
    var curY = 25 + this.y + this.textStartY;

    // begin hack ---------------
    // The use of TitleColor is a hack - not a good practice
    // Should use a better data structure to allow this behavior -- fix it
    context.font = "bold 14px Verdana";   // could make this a class trait
    context.fillStyle = this.textTitleColor;
    while (i < 2)
    {
        if (curY > this.y+this.height)
        {
            curY -= (this.height)
        }
        if (curY > 15 + this.y)
        {
            context.fillText(this.text[i], this.x+5, curY);
        }
        curY += 20;
        i++;
    }
    // end hack ---------------

    context.font = "12px Verdana";
    context.fillStyle = this.textColor;
    while (i < this.text.length)
    {
        if (curY > this.y+this.height)
        {
            curY -= (this.height)
        }
        if (curY > 15 + this.y)
        {
            context.fillText(this.text[i], this.x+5, curY);
        }
        curY += 20;
        i++;
    }
    
    this.textStartY--;
    if (this.textStartY < 0)
    {
        this.textStartY = this.height;
    }
};

 
 
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// 'class' EZcredits											EZcredits
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
function EZcredits(backImage)
{
    //console.log("DEBUG: backImage sent = " + backImage);
    var menuBckgrndLoaded = 0; // 0 means false, private var
    this.menuBckgrndImg = new Image();
    this.menuBckgrndImg.onload = function () { 	menuBckgrndLoaded = 1; };
                                                //console.log("DEBUG: menu background loaded!" + menuBckgrndLoaded); };
    this.menuBckgrndImg.src = backImage;

    // Numbers are based on 640x480 canvas world space
    // Could redo to use CANVAS_WIDTH and HEIGHT to make certain all fit
    
    var GameTitle = new menuButton();
    GameTitle.text = "The Game - Credits";    // TODO: Set Game Name Correctly
    GameTitle.y = 20;
    GameTitle.width = 380;

    var playButton = new menuButton();
    playButton.text = "Play Game";

    var mainMenuButton = new menuButton();
    mainMenuButton.text = "Main Menu";
    mainMenuButton.y = playButton.y + 1.25 * playButton.height;
    
    var creditView = new insetView();
    creditView.x = playButton.x + playButton.width + 40;
    creditView.y = playButton.y;
    creditView.width = 320;
    creditView.height = 350;
    var i = 0;
    creditView.text[i++] = "The Game - Credits";      // TODO: Set game name and all correctly
    creditView.text[i++] = "-------------------------------------------";
    creditView.text[i++] = "Design and Layout: I. M. DeZine";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "Programming:       Sir CodeAlot";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "Art and Videos:    V.J. Artso";
    creditView.text[i++] = "   and public domain from http://pixabay.com/";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "Sound:  None Currently";
    creditView.text[i++] = "   But checkout http://www.freesound.org/";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "  ";
    creditView.text[i++] = "  ";
    
    // ----------------------------------------------------------------------------
    // Draw the Credits Screen
    // ----------------------------------------------------------------------------
    this.DrawCredits = function()
    {
        // Init Local Canvas variables
        var creditsCanvas = document.getElementById(CANVAS_CREDITS_ID);
        var creditsContext = creditsCanvas.getContext("2d");

        //console.log("DEBUG: menuBckgrndLoaded = " + this.menuBckgrndLoaded);
        if (menuBckgrndLoaded == 0) // && (this.menuB1loaded != 0) && (this.menuB2loaded != 0) ...
        {
            // --------------------------------------------------------------- Title Button
            GameTitle.drawButton(creditsContext);
            
            // Fill text with fun gradient
            // Create gradient
            var gradient = creditsContext.createLinearGradient(0,0,creditsCanvas.width,0);
            gradient.addColorStop("0","magenta");
            gradient.addColorStop("0.5","blue");
            gradient.addColorStop("1.0","red");
            creditsContext.fillStyle = gradient;
            creditsContext.fillText("Loading...", GameTitle.x + 10, GameTitle.y + 2.5*GameTitle.height);
        }
        else // if (menuBckgrndLoaded != 0) // && (this.menuB1loaded != 0) && (this.menuB2loaded != 0) ...
        {
            // draw background image
            creditsContext.drawImage(this.menuBckgrndImg, 
                                  0, 0, this.menuBckgrndImg.width, this.menuBckgrndImg.height,
                                  0, 0, creditsCanvas.width, creditsCanvas.height);
            
            // --------------------------------------------------------------- Draw Buttons
            GameTitle.drawButton(creditsContext);
            playButton.drawButton(creditsContext);
            mainMenuButton.drawButton(creditsContext);

            creditView.drawInsetView(creditsContext);
        }
    };

    // ----------------------------------------------------------------------------
    // This REQUIRES theGame to exist as a singleton object 
    // with the getMousePos() function -- could make that function part of 
    // this class too
    // ----------------------------------------------------------------------------
    this.doMenuClick = function(evt)
    {
        var menuCanvas = document.getElementById(CANVAS_MENU_ID);
        var gameCanvas = document.getElementById(CANVAS_GAME_ID);
        var creditsCanvas = document.getElementById(CANVAS_CREDITS_ID);

        var mousePos = theGame.getMousePos(creditsCanvas, evt);

        if ( playButton.coordsAreInside(mousePos.x, mousePos.y) == true)
        {
            gameCanvas.style.display    = "block";
            menuCanvas.style.display    = "none";
            creditsCanvas.style.display = "none";
            theGame.gameState = theGame.STATE_PLAYING;
        }
        else if ( mainMenuButton.coordsAreInside(mousePos.x, mousePos.y) == true)
        {
            gameCanvas.style.display    = "none";
            menuCanvas.style.display    = "block";
            creditsCanvas.style.display = "none";
            theGame.gameState = theGame.STATE_MENU;
        }
    };
};
